# Стартовый проект с gulp

Установка: выполнить в папке проекта: `npm i`.

Использование: `npm start` (дабы не ставить глобально 4-ю версию gulp, которая сейчас в альфе). После `npm start` можно через пробел указать задачу. К примеру `npm start less` выполнит только задачу `less` из `gulpfile.js` (полный список задач смотри в `gulpfile.js`).

`port=3004 npm start` — для запуска сервера автообновлений на указанном порту.



## Парадигма

- Используется именование классов и файлов по БЭМ.
- Каждый БЭМ-блок в своей папке внутри `/src/blocks/` (less, js (не обязательно), картинки (не обязательно), разметка (не обязательно)).
- Есть глобальные файлы: css, js, шрифты, картинки, less-файлы (переменные, глобальная стилизация...).
- Есть диспетчер подключений `/src/less/style.less`. Если в нем импортирован less-файл какого-либо блока, этот блок считается используемым (обрабатывается его js и доп. файлы).

Каждый блок — как минимум, папка и less-файл. Максимум возможностей — см. файлы внутри `/src/blocks/demo-block`.



## Назначение папок

```
build/          # Сюда собирается проект, здесь работает сервер автообновлений.
src/            # Исходные файлы
  _include/     # - фрагменты html, обще для всех страниц
  blocks/       # - блоки (компоненты) проекта
  css/          # - глобальный css-файл (не обязательно — подключится только если не пустой)
  fonts/        # - глобальные шрифты (не обязательно — будут скопированы только если есть)
  img/          # - глобальные картинки (не обязательно, будут скопированы только из корня этой папки)
  js/           # - глобальный js-файл (не обязательно — подключится только если не пустой)
  less/         # - диспетчер подключений и глобальные стили
  _blocks_library.html  # библиотека блоков проекта
  index.html            # главная страница проекта
```
